小白如何如何理解滑动窗口最大值问题python

文章目录

题目描述

给你一个整数数组 nums,有一个大小为 k 的滑动窗口从数组的最左侧移动到数组的最右侧。你只可以看到在滑动窗口内的 k 个数字。滑动窗口每次只向右移动一位。

举例:

输入:nums = 1,3,-1,-3,5,3,6,7, k = 3

输出:3,3,5,5,6,7

解释:

滑动窗口的位置 最大值


1 3 -1 -3 5 3 6 7 3

1 3 -1 -3 5 3 6 7 3

1 3 -1 -3 5 3 6 7 5

1 3 -1 -3 5 3 6 7 5

1 3 -1 -3 5 3 6 7 6

1 3 -1 -3 5 3 6 7 7

思路

很容易想到暴力求解,遍历数据i:i+k取出max最大值即可,但是这种做法容易暴力超时,因此引出了自DIY的队列,主要关注的是什么时候弹出,什么时候加入队列

什么时候弹出元素

1.当遍历个数大于k的时候,弹出queue左侧==numsi-k

2.当队列最右侧元素小于numsi,弹出右侧元素,因为他不可能是最大值了,队列内最多只有k个值,所以遍历到的这个元素才能成为最大值

什么时候加入元素

没遍历一次长度大于k的时候就加元素

代码示例和解释

python 复制代码
from collections import deque
def max SlidingWindow(nums, k):
	queue = deque() # 双端都能插入删除的队列
	res = [] # 存放最后的结果
	# 把前面三个元素按需求加入到deque
	for i in range(k):
		while queue and nums[i] > queue[-1]:
			queue.pop() # 弹出右边的元素,不可能成为最大值
		deque.append(nums[i])
	# 从k开始遍历后面的每个元素
	for i in range(k, len(nums)):
		# 只有遍历到的元素queue[0]等于nums[i-k]才需要弹出元素
		if queue and queue[0] == nums[i-k]:
			queue.popleft()
		while queue and queue[-1] < nums[i]:
			queue.pop()
		queue.append(nums[i])
		res.append(queue[0]) # 加入最大值
	return res

*注意点:queue内部的元素个数一定是小于等于k的,比如k = 3的时候,因为遍历到长度第4个元素,如果queue首元素和numsi-k元素相等就会有pop操作,即使不相等,其他需要pop()的元素也会被push的过程弹出,所以queue的长度始终不可能大于k

相关推荐
Dream it possible!2 小时前
LeetCode 面试经典 150_多维动态规划_交错字符串(97_C++_中等)
算法·leetcode·面试·动态规划
心抵鹊3 小时前
算法之双指针系列(一)
算法·leetcode
十二3 小时前
【洛谷题解】P1083 [NOIP 2012 提高组] 借教室(二分答案 + 差分)
数据结构·c++·算法·蓝桥杯
小此方4 小时前
[算法实战论:动态规划]回文串问题的dp解法,回文串问题的母题,以及以此为基础的派生题
算法·动态规划
Pniubi4 小时前
力扣560.和为k的子数组
算法·leetcode·职场和发展
D e re k ZH5 小时前
C++ 从零入门(一):基础语法与程序结构
数据结构·c++·算法
Pniubi5 小时前
力扣438.找到字符串中所有字母异位词
算法·leetcode·职场和发展
東隅已逝,桑榆非晚8 小时前
算法6. 双指针法-查找总价格为目标的两个商品
c++·学习·算法
Eyfcom8 小时前
〖物联网终端实战 01〗UWB 室内高精度定位:仓储 AGV 与人员的厘米级轨迹追踪
物联网·算法·物流系统·快递系统·跨境物流快递系统·物联网终端实战
bro_Java6669 小时前
《排序的底层逻辑:比较、交换与分治》
java·算法·排序算法